#!/usr/bin/env python
# -*- coding: utf-8 -*-

__author__ = 'Shiva Prasad Rao <shivrao@cisco.com>'


import amulet
import unittest
import os


N1KV_SOURCE = os.environ.get("N1KV_SOURCE", None)

if not N1KV_SOURCE:
    raise Exception("Please define the N1KV_SOURCE"
                    " environment variable")


class VemTest(unittest.TestCase):

    def setUp(self):
        pass

    def test_deployment_single(self):
        """Test a vem-nova-compute deployment"""
        self.deployment = amulet.Deployment(series="trusty", sentries=False)
        self.deployment.add('nova-compute', charm='cs:trusty/nova-compute')
        self.deployment.add("vem")
        self.deployment.configure("vem", {
            'n1kv-source': N1KV_SOURCE,
            'uplink_profile': 'phys dummy profile sys-uplink'
        })
        self.deployment._relate("nova-compute", "vem")
        seconds = 600

        try:
            self.deployment.setup(timeout=seconds)
        except amulet.helpers.TimeoutError:
            message = 'The environment did not setup in %d seconds.' % seconds
            amulet.raise_status(amulet.SKIP, msg=message)
        except:
            raise


if __name__ == "__main__":
    unittest.main()
