# -*- coding: utf-8 -*-
from mock import patch
from test_utils import CharmTestCase
import common

TO_PATCH = [
    # charmhelpers.core.hookenv
    'config',
]


def fake_filter(packages):
    return packages


class VemCommonTest(CharmTestCase):

    def setUp(self):
        super(VemCommonTest, self).setUp(common, TO_PATCH)
        self.config.side_effect = self.test_config.get

    @patch('common.juju_log')
    @patch('yaml.load')
    def test_host_spec_config_hook(self, yaml_load, juju_log):
        host_conf = {
            'n1kv-vsm-ip': '10.10.10.250',
            'n1kv-vsm-domain-id': '100',
            'n1kv-source': '',
            'n1kv-version': '',
            'vsm_conf_from_rel': 'false',
            'host_mgmt_intf': 'eth0',
            'uplink_profile': 'phys eth0 profile sys-uplink',
            'vtep_config': '',
            'node_type': 'network',
            'vtep_in_same_subnet': 'no',
        }
        yaml_load.return_value = {'maas-node-1': host_conf}
        result = common.get_host_specific_config('maas-node-1')
        ex = {'vtep_config': '', 'n1kv-vsm-domain-id': '100', 'vtep_in_same_subnet': 'no', 'host_mgmt_intf': 'eth0', 'node_type': 'network', 'uplink_profile': 'phys eth0 profile sys-uplink', 'n1kv-vsm-ip': '10.10.10.250'}
        self.assertEquals(ex, result)
        result = common.get_host_specific_config('maas-node-2')
        ex = {'vtep_config': '', 'n1kv-vsm-domain-id': 1000, 'vtep_in_same_subnet': 'no', 'host_mgmt_intf': 'eth0', 'node_type': 'compute', 'uplink_profile': 'phys eth8 profile sys-uplink', 'n1kv-vsm-ip': '10.10.10.10'}
        self.assertEquals(ex, result)
