# -*- coding: utf-8 -*-
from mock import (
    call,
    patch
)
from test_utils import (
    CharmTestCase,
    patch_open
)
import config_changed

TO_PATCH = [
    # charmhelpers.core.hookenv
    'config',
]


def fake_filter(packages):
    return packages


class Vem_Config_Changed_Test(CharmTestCase):

    def setUp(self):
        super(Vem_Config_Changed_Test, self).setUp(config_changed, TO_PATCH)
        self.config.side_effect = self.test_config.get

    @patch('common.enable_uplink')
    @patch('common.update_n1kv_config')
    @patch('common.get_host_specific_config')
    @patch('yaml.load')
    def test_config_changed_hook(self, yaml_load, host_spec_config, update_n1kv_conf, enable_uplink):
        host_conf = {
            'n1kv-vsm-ip': '10.10.10.250',
            'n1kv-vsm-domain-id': '100',
            'n1kv-source': '',
            'n1kv-version': '',
            'vsm_conf_from_rel': 'false',
            'host_mgmt_intf': 'eth0',
            'uplink_profile': 'phy eth0 profile sys-uplink',
            'vtep_config': '',
            'node_type': 'network',
            'vtep_in_same_subnet': 'no',
        }
        yaml_load.return_value = {'n1kv_conf': host_conf}
        self.test_config.set('n1kv-version', '')
        self.test_config.set('n1kv-source', '')
        ex_open = [
            call('data.yaml', 'r'),
            call('data.yaml', 'w'),
        ]
        host_spec_config.return_value = host_conf
        with patch_open() as (_open, _file):
            config_changed.config_changed()
            self.assertEquals(ex_open, _open.call_args_list)
            _file.write.assert_called_with("{n1kv_conf: {host_mgmt_intf: eth0, n1kv-source: '', n1kv-version: '', n1kv-vsm-domain-id: '100',\n    n1kv-vsm-ip: 10.10.10.250, node_type: network, uplink_profile: phy eth0 profile\n      sys-uplink, vsm_conf_from_rel: 'false', vtep_config: '', vtep_in_same_subnet: 'no'}}\n")
            self.assertTrue(_open.called)
