# -*- coding: utf-8 -*-
from mock import (
    call,
    patch
)
from test_utils import (
    CharmTestCase,
    patch_open
)
import common
import install


TO_PATCH = [
    # charmhelpers.core.hookenv
    'config',
    'execd_preinstall',
    'apt_update',
    'apt_install',
    #common
    'configure_installation_source',
]


def fake_filter(packages):
    return packages


class VemInstallTest(CharmTestCase):

    def setUp(self):
        super(VemInstallTest, self).setUp(install, TO_PATCH)
        self.config.side_effect = self.test_config.get

    @patch.object(common, 'configure_installation_source')
    @patch('os.path.exists')
    @patch('os.remove')
    def test_install_hook(self, remove, path_exists, config_src):
        n1kv_version = ''
        src = 'ppa:cisco-n1kv/n1kv-updates'
        self.test_config.set('n1kv-version', n1kv_version)
        self.test_config.set('n1kv-source', src)
        config_src.return_value = True
        path_exists.return_value = True
        ex_open = [
            call('data.yaml', 'r'),
            call('data.yaml', 'w'),
        ]
        with patch_open() as (_open, _file):
            _file.read.return_value = "n1kv_conf:\n  n1kv-source:\n"
            install.install()
            self.assertEquals(ex_open, _open.call_args_list)
            _file.write.assert_called_with("{!!python/unicode 'n1kv_conf': {!!python/unicode 'n1kv-source': 'ppa:cisco-n1kv/n1kv-updates'}}\n")
            self.assertTrue(_open.called)
